package com.example.kafka.consumer;

import com.example.kafka.service.OrderServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.stereotype.Component;

@Component
public class MessageConsumer {

    private static final Logger log = LoggerFactory.getLogger(MessageConsumer.class.getName());
    @Autowired
    private OrderServiceImpl orderService;

    @KafkaListener(topics = "${app.topic.name}",groupId = "group1")
    public void readMessage(String order){
        orderService.validateOrder(order).doOnNext(log.info("order has been validated"));
    }   

}
