package com.example.kafka.service;

import com.example.kafka.entity.Order;
import com.example.kafka.enumerator.OrderStatus;
import com.example.kafka.producer.MessageProducer;
import com.example.kafka.repository.OrderRepository;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;
import reactor.core.publisher.Mono;

import java.util.Map;

@Service
public class OrderServiceImpl implements OrderService {

    private static final Logger log = LoggerFactory.getLogger(OrderServiceImpl.class.getName());

    @Autowired
    private OrderRepository orderRepository;

    @Autowired
    private UserServiceImpl userService;

    @Autowired
    private MessageProducer messageProducer;
    @Override
    public Mono<Order> saveOrderIntoDB(Order order){
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            messageProducer.publishOrder(objectMapper.writeValueAsString(order));
        } catch(JsonProcessingException e) {
            log.error("Caught Exception {}:: ",e);
        }
        return orderRepository.save(order);
    }

    @Override
    public Mono<Order> findById(String orderId){
        return orderRepository.findById(orderId);
    }

    @Override
    public Mono<Order> validateOrder(String orderJson) {
//        try {
            return orderRepository.findById("1")
                    .flatMap(dbOrder -> {
                        dbOrder.setOrderStatus(OrderStatus.REJECTED);
                        return orderRepository.save(dbOrder);
                    });
            //            ObjectMapper mapper = new ObjectMapper();
//            Order order = mapper.readValue(orderJson,Order.class);
//            double amount = order.getAmount();
//            double balance = userService.findById(order.getId()).block().getBalance();
//            OrderStatus orderStatus;
//            if(amount>balance) {
//                orderStatus=OrderStatus.REJECTED;
//            } else {
//                orderStatus=OrderStatus.ACCEPTED;
//            }
//            Order dbOrder = orderRepository.findById(order.getId()).block();
//            if(dbOrder!=null)
//            {
//                dbOrder.setOrderStatus(orderStatus);
//            }
//            orderRepository.save(dbOrder);
//        } catch(JsonProcessingException e) {
//            log.error("Caught Exception {}:: ",e);
//        }
    }
}
